de.caff.util

## Class CountingOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - de.caff.util.CountingOutputStream

- All Implemented Interfaces:
    java.io.Closeable, java.io.Flushable, java.lang.AutoCloseable

      public class CountingOutputStream
      extends java.io.OutputStream

  A wrapper output streams which counts the bytes written so far.
  Since:
    2005
  Author:
    Rammi

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CountingOutputStream(java.io.OutputStream wrapped)` Creat a counting output stream which wraps the given output stream.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes this output stream and releases any system resources associated with this stream.
    `void` | `flush()` Flushes this output stream and forces any buffered output bytes to be written out.
    `long` | `getCount()` Get the bytes written so far.
    `void` | `write(byte[] b)` Writes `b.length` bytes from the specified byte array to this output stream.
    `void` | `write(byte[] b, int off, int len)` Writes `len` bytes from the specified byte array starting at offset `off` to this output stream.
    `void` | `write(int b)` Writes the specified byte to this output stream.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CountingOutputStream

          public CountingOutputStream(java.io.OutputStream wrapped)

      Creat a counting output stream which wraps the given output stream.
      Parameters:
        `wrapped` - wrapped

  - ### Method Detail

    - #### getCount

          public long getCount()

      Get the bytes written so far. Notice that it may be necessary to call flush to be sure that the bytes are indeed written and not buffered in underlying streams.
      Returns:
        number of bytes written so far

    - #### write

          public void write(int b)
                     throws java.io.IOException

      Writes the specified byte to this output stream. The general contract for `write` is that one byte is written to the output stream. The byte to be written is the eight low-order bits of the argument `b`. The 24 high-order bits of `b` are ignored.

      Subclasses of `OutputStream` must provide an implementation for this method.

      Specified by:
        `write` in class `java.io.OutputStream`
      Parameters:
        `b` - the `byte`.
      Throws:
        `java.io.IOException` - if an I/O error occurs. In particular, an `IOException` may be thrown if the output stream has been closed.

    - #### close

          public void close()
                     throws java.io.IOException

      Closes this output stream and releases any system resources associated with this stream. The general contract of `close` is that it closes the output stream. A closed stream cannot perform output operations and cannot be reopened.

      The `close` method of `OutputStream` does nothing.

      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException` - if an I/O error occurs.

    - #### flush

          public void flush()
                     throws java.io.IOException

      Flushes this output stream and forces any buffered output bytes to be written out. The general contract of `flush` is that calling it is an indication that, if any bytes previously written have been buffered by the implementation of the output stream, such bytes should immediately be written to their intended destination.

      The `flush` method of `OutputStream` does nothing.

      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException` - if an I/O error occurs.

    - #### write

          public void write(@NotNull
                            byte[] b)
                     throws java.io.IOException

      Writes `b.length` bytes from the specified byte array to this output stream. The general contract for `write(b)` is that it should have exactly the same effect as the call `write(b, 0, b.length)`.
      Overrides:
        `write` in class `java.io.OutputStream`
      Parameters:
        `b` - the data.
      Throws:
        `java.io.IOException` - if an I/O error occurs.
      See Also:
        `OutputStream.write(byte[], int, int)`

    - #### write

          public void write(@NotNull
                            byte[] b,
                            int off,
                            int len)
                     throws java.io.IOException

      Writes `len` bytes from the specified byte array starting at offset `off` to this output stream. The general contract for `write(b, off, len)` is that some of the bytes in the array `b` are written to the output stream in order; element `b[off]` is the first byte written and `b[off+len-1]` is the last byte written by this operation.

      The `write` method of `OutputStream` calls the write method of one argument on each of the bytes to be written out. Subclasses are encouraged to override this method and provide a more efficient implementation.

      If `b` is `null`, a `NullPointerException` is thrown.

      If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown.

      Overrides:
        `write` in class `java.io.OutputStream`
      Parameters:
        `b` - the data.
        `off` - the start offset in the data.
        `len` - the number of bytes to write.
      Throws:
        `java.io.IOException` - if an I/O error occurs. In particular, an `IOException` is thrown if the output stream is closed.